package dev.shadowsoffire.apotheosis.adventure.affix.effect;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.mojang.datafixers.kinds.App;
import com.mojang.datafixers.kinds.Applicative;
import com.mojang.serialization.Codec;
import com.mojang.serialization.codecs.RecordCodecBuilder;
import dev.shadowsoffire.apotheosis.Apoth;
import dev.shadowsoffire.apotheosis.adventure.affix.Affix;
import dev.shadowsoffire.apotheosis.adventure.affix.AffixHelper;
import dev.shadowsoffire.apotheosis.adventure.affix.AffixInstance;
import dev.shadowsoffire.apotheosis.adventure.affix.AffixType;
import dev.shadowsoffire.apotheosis.adventure.loot.LootCategory;
import dev.shadowsoffire.apotheosis.adventure.loot.LootRarity;
import dev.shadowsoffire.apotheosis.adventure.socket.gem.bonus.GemBonus;
import dev.shadowsoffire.placebo.util.StepFunction;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import net.minecraft.core.particles.ParticleOptions;
import net.minecraft.core.particles.ParticleTypes;
import net.minecraft.network.chat.Component;
import net.minecraft.network.chat.MutableComponent;
import net.minecraft.server.level.ServerLevel;
import net.minecraft.sounds.SoundEvents;
import net.minecraft.sounds.SoundSource;
import net.minecraft.world.entity.Entity;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.entity.item.ItemEntity;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.item.ItemStack;
import net.minecraftforge.common.capabilities.ForgeCapabilities;
import net.minecraftforge.event.entity.living.LivingDeathEvent;
import net.minecraftforge.event.entity.living.LivingDropsEvent;
import net.minecraftforge.items.IItemHandler;
import net.minecraftforge.items.IItemHandlerModifiable;

public class FestiveAffix extends Affix {
  public static Codec<dev.shadowsoffire.apotheosis.adventure.affix.effect.FestiveAffix> CODEC;
  
  protected final Map<LootRarity, StepFunction> values;
  
  static {
    CODEC = RecordCodecBuilder.create(inst -> inst.group((App)GemBonus.VALUES_CODEC.fieldOf("values").forGetter(())).apply((Applicative)inst, dev.shadowsoffire.apotheosis.adventure.affix.effect.FestiveAffix::new));
  }
  
  public FestiveAffix(Map<LootRarity, StepFunction> values) {
    super(AffixType.ABILITY);
    this.values = values;
  }
  
  public MutableComponent getDescription(ItemStack stack, LootRarity rarity, float level) {
    return Component.m_237110_("affix." + getId() + ".desc", new Object[] { fmt(100.0F * getTrueLevel(rarity, level)) });
  }
  
  public Component getAugmentingText(ItemStack stack, LootRarity rarity, float level) {
    MutableComponent comp = getDescription(stack, rarity, level);
    MutableComponent mutableComponent1 = Component.m_237110_("%s%%", new Object[] { fmt(100.0F * getTrueLevel(rarity, 0.0F)) });
    MutableComponent mutableComponent2 = Component.m_237110_("%s%%", new Object[] { fmt(100.0F * getTrueLevel(rarity, 1.0F)) });
    return (Component)comp.m_7220_((Component)valueBounds((Component)mutableComponent1, (Component)mutableComponent2));
  }
  
  public boolean canApplyTo(ItemStack stack, LootCategory cat, LootRarity rarity) {
    return (cat.isLightWeapon() && this.values.containsKey(rarity));
  }
  
  private float getTrueLevel(LootRarity rarity, float level) {
    return ((StepFunction)this.values.get(rarity)).get(level);
  }
  
  private static String MARKER = "apoth.equipment";
  
  public void markEquipment(LivingDeathEvent e) {
    if (e.getEntity() instanceof Player || e.getEntity().getPersistentData().m_128471_("apoth.no_pinata"))
      return; 
    IItemHandler inv = (IItemHandler)e.getEntity().getCapability(ForgeCapabilities.ITEM_HANDLER).orElse(null);
    if (inv instanceof IItemHandlerModifiable) {
      IItemHandlerModifiable iihm = (IItemHandlerModifiable)inv;
      for (int i = 0; i < inv.getSlots(); i++) {
        ItemStack stack = inv.getStackInSlot(i);
        if (!stack.m_41619_()) {
          stack.m_41784_().m_128379_(MARKER, true);
          iihm.setStackInSlot(i, stack);
        } 
      } 
    } 
    e.getEntity().m_20158_().forEach(i -> {
          if (!i.m_41619_())
            i.m_41784_().m_128379_(MARKER, true); 
        });
  }
  
  public void drops(LivingDropsEvent e) {
    LivingEntity dead = e.getEntity();
    if (dead instanceof Player || dead.getPersistentData().m_128471_("apoth.no_pinata"))
      return; 
    Entity entity = e.getSource().m_7639_();
    if (entity instanceof Player) {
      Player player = (Player)entity;
      if (!e.getDrops().isEmpty()) {
        AffixInstance inst = (AffixInstance)AffixHelper.getAffixes(player.m_21205_()).get(Apoth.Affixes.FESTIVE);
        if (inst != null && inst.isValid() && (player.m_9236_()).f_46441_.m_188501_() < getTrueLevel((LootRarity)inst.rarity().get(), inst.level())) {
          player.m_9236_().m_6263_(null, dead.m_20185_(), dead.m_20186_(), dead.m_20189_(), SoundEvents.f_11913_, SoundSource.BLOCKS, 4.0F, (1.0F + (
              (player.m_9236_()).f_46441_.m_188501_() - (player.m_9236_()).f_46441_.m_188501_()) * 0.2F) * 0.7F);
          ((ServerLevel)player.m_9236_()).m_8767_((ParticleOptions)ParticleTypes.f_123812_, dead.m_20185_(), dead.m_20186_(), dead.m_20189_(), 2, 1.0D, 0.0D, 0.0D, 0.0D);
          List<ItemEntity> drops = new ArrayList<>(e.getDrops());
          for (ItemEntity item : drops) {
            if (item.m_32055_().m_41782_() && item.m_32055_().m_41783_().m_128441_(MARKER))
              continue; 
            for (int i = 0; i < 20; i++)
              e.getDrops().add(new ItemEntity(player.m_9236_(), item.m_20185_(), item.m_20186_(), item.m_20189_(), item.m_32055_().m_41777_())); 
          } 
          for (ItemEntity item : e.getDrops()) {
            if (!item.m_32055_().m_41720_().m_41465_()) {
              item.m_6034_(dead.m_20185_(), dead.m_20186_(), dead.m_20189_());
              item.m_20334_(-0.3D + (dead.m_9236_()).f_46441_.m_188500_() * 0.6D, 0.3D + (dead.m_9236_()).f_46441_.m_188500_() * 0.3D, -0.3D + (dead.m_9236_()).f_46441_.m_188500_() * 0.6D);
            } 
          } 
        } 
      } 
    } 
  }
  
  public void removeMarker(LivingDropsEvent e) {
    e.getDrops().stream().forEach(ent -> {
          ItemStack s = ent.m_32055_();
          if (s.m_41782_() && s.m_41783_().m_128441_(MARKER)) {
            s.m_41783_().m_128473_(MARKER);
            if (s.m_41783_().m_128456_())
              s.m_41751_(null); 
          } 
          ent.m_32045_(s);
        });
  }
  
  public Codec<? extends Affix> getCodec() {
    return (Codec)CODEC;
  }
}
